function AI() {

    var _this = this;
    this.combo = [];
    this.tempCombo = [];
    var types = [
        {
            'type': 'luck',
            'url': 'assets/luck.png',
            'color': 'Green'
        },
        {
            'type': 'love',
            'url': 'assets/love.png',
            'color': 'Pink'
        },
        {
            'type': 'passion',
            'url': 'assets/passion.png',
            'color': 'Orange'
        },
        {
            'type': 'friendship',
            'url': 'assets/friendship.png',
            'color': 'Purple'
        },
        {
            'type': 'gold',
            'url': 'assets/gold.png',
            'color': 'Yellow'
        },
        {
            'type': 'romance',
            'url': 'assets/romance.png',
            'color': 'Grey'
        }
    ];

    this.pickCombination = function () {
        var slot1 = types[getRandom(0, types.length - 1)];
        var slot2 = types[getRandom(0, types.length - 1)];
        var slot3 = types[getRandom(0, types.length - 1)];
        var slot4 = types[getRandom(0, types.length - 1)];
        var slot5 = types[getRandom(0, types.length - 1)];
        var slot6 = types[getRandom(0, types.length - 1)];

        this.combo = [slot1, slot2, slot3, slot4, slot5, slot6];
        this.tempCombo = [_.clone(slot1), _.clone(slot2), _.clone(slot3), _.clone(slot4), _.clone(slot5), _.clone(slot6)];
        return [slot1, slot2, slot3, slot4, slot5, slot6];
    };

    /**
     * [getHint description]
     * @return {[type]} [description]
     */

    this.getHint = function (number) {
        var index = getRandom(1, types.length - 1);
        return String(this.combo[index - 1].color + " on position " + index);
    };

    /**
     * [getCombo description]
     * @return {[type]} [description]
     */

    this.getCombo = function () {
        var res = [];
        for (var o = 0; o < this.combo.length; o++) {
            res.push(_.clone(this.combo[o]));
        }

        return res;
    };

    /**
     * [getComboReal description]
     * @return {[type]} [description]
     */

    this.getComboReal = function () {
        return this.combo;
    };

    /**
     * getRandom * Description
     * @param {type} max* Description
     * @param {type} min* Description
     **/
    function getRandom(min, max) {
        return Math.floor(Math.random() * (max - min + 1) + min);
    }

    /**
     * [createAIshelve description]
     * @return {[type]} [description]
     */

    function createAIshelve() {
        var img = Registry.cachedImages["assets/simpleShelf.png"];
        var AIGroup = new Kinetic.Group();
        var scale = Registry.scale + 0.1;
        if (scale > 0.8) {
            scale = 0.8;
        }
        var aiShelf = new Kinetic.Image({
            image: img,
            id: "aiShelf",
            x: 160,
            y: 150,
            scale: scale
        });

        AIGroup.add(aiShelf);
        Registry.mainLayer.add(AIGroup);
        Registry.mainLayer.draw();
        Registry.AIGroup = AIGroup;

        var slots = Registry.AI.pickCombination();
        createSecretCombination(slots);
        //window.console.log(slots);
    }

    /**
     * [createSecretCombination description]
     * @param  {[type]} slots [description]
     * @return {[type]}       [description]
     */

    function createSecretCombination(slots) {

        var group = new Kinetic.Group();

        for (var i = 0; i < slots.length; i++) {

            var slot = new Kinetic.Image({
                image: Registry.cachedImages["assets/qm.png"],
                x: (80 * i) + 210,
                y: 110,
                scale: 0.5
            });

            slot.on("mouseover", mouseCursor);
            slot.on("mouseout", returnCursor);
            group.add(slot);
        }

        Registry.AIGroup.add(group);
        Registry.mainLayer.draw();

    }

    /**
     * [revealCombination description]
     * @return {[type]} [description]
     */

    function revealCombination() {
        var children = Registry.AIGroup.getChildren();
        children[1].destroyChildren();
        var combo = Registry.AI.getComboReal();
        var scale = Registry.scale + 0.1;
        if (scale > 0.6) {
            scale = 0.6;
        }
        for (var i = 0; i < combo.length; i++) {

            var img = new Kinetic.Image({
                image: Registry.cachedImages["assets/" + String(combo[i].type).toLowerCase() + ".png"],
                x: ((i + 2) * 60) + 145,
                y: 70,
                scale: scale
            });

            children[1].add(img);

        }

        Registry.mainLayer.draw();
    }

    this.revealCombination = function(){
        revealCombination();
    };


    this.createAIshelve = function () {
        createAIshelve();
    };

    return this;
};