var audio;
window.onload = function () {

  audio = window.audioJS({
    file: 'assets/audio/track.mp3',
    loop: true,
    volume: 0.3
  });

  audio.play();

  var assetsList = [
    "assets/menu.jpg",
    "assets/play.png",
    "assets/bg.jpg",
    "assets/board.png",
    "assets/colorAndPosition.png",
    "assets/friendship.png",
    "assets/gold.png",
    "assets/littleShelf.png",
    "assets/love.png",
    "assets/luck.png",
    "assets/noPosition.png",
    "assets/nothing.png",
    "assets/passion.png",
    "assets/qm.png",
    "assets/romance.png",
    "assets/shelf.png",
    "assets/sidePanel.png",
    "assets/simpleShelf.png",
    "assets/superShelf.png",
    "assets/test.png",
    "assets/modal.png",
    "assets/hint.png",
    "assets/coin2.png",
    "assets/sound.png",
    "assets/nosound.png",
    "assets/replay.png",
    "assets/info.png",
    "assets/infoScreen.png"
  ];

  createStage();
  initBackground();
  checkSize(true);
  createLoader(assetsList.length);
  loadAssets(assetsList, updateLoader, init);

};



/**
 * [init description]
 * @return {[type]} [description]
 */

function init() {

  window.console.log("init!");
  createBoard();
  checkSize();

  Registry.store = new innerstore();
  var iAI = new AI();
  Registry.AI = iAI;

  createMenu();

  Registry.assetsLoaded = true;
  updateLoader("kill");
}

function createMenu() {
  var group = new Kinetic.Group();

  var bg = new Kinetic.Image({
    image: Registry.cachedImages["assets/menu.jpg"]
  });


  var play = new Kinetic.Image({
    image: Registry.cachedImages["assets/play.png"],
    x: Math.ceil((((Registry.stage.getWidth()) / 2) - (297 / 2)) * Math.round(Registry.scale)),
    y: 554 * Registry.scale,
    scale: 0
  });

  window.console.log(">>>>> ", play.getX());

  var sound = new Kinetic.Image({
    image: Registry.cachedImages["assets/sound.png"],
    x: ((Registry.stage.getWidth() * Registry.scale)) - (100),
    y: (Registry.stage.getHeight() * Registry.scale) - 100
  });

  group.add(bg);
  group.add(play);
  group.add(sound);

  var layer = new Kinetic.Layer();
  layer.add(group);
  Registry.stage.add(layer);
  Registry.menuLayer = layer;

  play.on("mousedown touchstart", function () {
    var tween = new Kinetic.Tween({
      node: Registry.menuLayer,
      duration: 1,
      opacity: 0,
      onFinish: function () {
        Registry.menuLayer.destroy();
      }
    });

    tween.play();
  });

  play.on("mouseover", mouseCursor);
  play.on("mouseout", returnCursor);
  sound.on("mouseover", mouseCursor);
  sound.on("mouseout", returnCursor);
  sound.on("click touchstart", function (e) {
    var source = $(e.targetNode.getImage()).attr("src");
    if (source === "assets/sound.png") {
      stopSound(e);
    } else {
      playSound(e);
    }

  });

  Registry.stage.draw();

  setTimeout(function (play) {
    var tween2 = new Kinetic.Tween({
      node: play[0],
      duration: 1,
      scaleX: 1,
      scaleY: 1,
      easing: Kinetic.Easings["BackEaseOut"]
    });

    tween2.play();
  }, 500, [play]);

}

/**
 * [createStage description]
 * @return {[type]} [description]
 */

function createStage() {
  var stage = new Kinetic.Stage({
    container: 'board',
    width: 810,
    height: 1024
  });
  var layer = new Kinetic.Layer();
  var gfxGroup = new Kinetic.Group();

  stage.add(layer);
  layer.add(gfxGroup);
  Registry.stage = stage;
  Registry.mainLayer = layer;
  Registry.gfxGroup = gfxGroup;
}

/**
 * [createBoard description]
 * @return {[type]} [description]
 */

function createBoard() {
  var img = new Image();
  img.onload = function () {

    var board = new Kinetic.Image({
      image: img,
      width: 810,
      height: 1024,
      id: "board"
    });

    Registry.gfxGroup.add(board);
    Registry.mainLayer.draw();
    board.moveToBottom();
    board.moveDown();

    AddSideBoard();
  };

  img.src = "assets/board.png";
}

/**
 * [AddSideBoard description]
 * @param {[type]} board [description]
 */

function AddSideBoard(board) {

  var img = new Image();
  img.onload = function () {

    var sideBoard = new Kinetic.Image({
      image: img,
      x: 20,
      y: 23
    });

    var children = Registry.gfxGroup.getChildren();
    window.console.log(children);
    Registry.gfxGroup.add(sideBoard);
    Registry.mainLayer.draw();
    children[0].moveToBottom();
    children[0].moveDown();
    setTimeout(function () {
      sideBoard.moveToTop();
      window.console.log("timeout");
    }, 2000);
    sideBoard.moveUp(1);

    AddShelves();

  };
  img.src = "assets/sidePanel.png";

}

/**
 * [AddShelves description]
 */

function AddShelves() {
  var img = new Image();
  img.onload = function () {

    var mod = Math.floor(Registry.stage.getHeight() / 7);
    for (var i = 0; i < 6; i++) {
      var shelf = new Kinetic.Image({
        x: 25,
        y: (i * mod) + mod,
        image: img
      });

      Registry.gfxGroup.add(shelf);
      Registry.mainLayer.draw();
    }

    AddPotionsOnShelves();

  };
  img.src = "assets/littleShelf.png";
}

/**
 * [AddPotionsOnShelves description]
 */

function AddPotionsOnShelves() {

  var mod = Math.floor(Registry.stage.getHeight() / 7);
  window.console.log("ADDING POTIONS: ", mod);
  var potionsGroup = new Kinetic.Group();
  var potionsArr = [
    {
      "source": "assets/friendship.png",
      "label": "Friendship"
    },
    {
      "source": "assets/gold.png",
      "label": "Gold"
    },
    {
      "source": "assets/love.png",
      "label": "Love"
    },
    {
      "source": "assets/luck.png",
      "label": "Luck"
    },
    {
      "source": "assets/passion.png",
      "label": "Passion"
    },
    {
      "source": "assets/romance.png",
      "label": "Romance"
    }
  ];

  for (var i = 0; i < potionsArr.length; i++) {
    var split = String(potionsArr[i].source).split("/");
    var ID = potionsArr[i].label;

    var potion = new Kinetic.Image({
      x: 55,
      y: (i * mod) + 70,
      image: Registry.cachedImages[potionsArr[i].source],
      id: ID,
      name: "potion",
      scale: 0.6
    });
    potion.setStrokeEnabled(true);
    potion.on("mousedown touchstart", getChosenPotion);
    potion.on("mouseover", mouseCursor);
    potion.on("mouseout", returnCursor);
    potionsGroup.add(potion);
    Registry.potions = [];
    Registry.potions.push(potion);
  }

  Registry.mainLayer.add(potionsGroup);
  Registry.mainLayer.batchDraw();
  createBigShelves();
}

/**
 * [addEventListenersToPotions description]
 * @param {[type]} potions [description]
 */

function addEventListenersToPotions(potions) {
  var pot;
  for (var i = 0; i < potions.length; i++) {
    pot = potions[i];
    pot.on("mousedown touchstart", getChosenPotion);
    pot.on("mouseover", mouseCursor);
    pot.on("mouseout", returnCursor);
  }
}

/**
 * [mouseCursor description]
 * @return {[type]} [description]
 */

function mouseCursor() {
  document.body.style.cursor = 'pointer';
}

/**
 * [returnCursor description]
 * @return {[type]} [description]
 */

function returnCursor() {
  document.body.style.cursor = 'default';
}

/**
 * [createBigShelves description]
 * @return {[type]} [description]
 */

function createBigShelves() {
  var mod = Math.floor(Registry.stage.getHeight());
  var img = Registry.cachedImages['assets/superShelf.png'];
  var group = new Kinetic.Group();
  var scale = Registry.scale + 0.1;
  Registry.shelves = [];
  if (scale > 0.8) {
    scale = 0.8;
  }
  for (var i = 0; i < 6; i++) {
    group = new Kinetic.Group({
      x: 160,
      y: (1024 - 160) - (i * 120), //Math.round(mod - (i* (mod/5) )) * Registry.scale,
      name: "shelfGroup"
    });
    var shelf = new Kinetic.Image({
      image: img,
      x: 0,
      y: 0, //Math.round(mod - (i* (mod/5) )) * Registry.scale,
      id: "group_" + i,
      scale: scale,
      name: "itemShelf"
    });

    group.add(shelf);

    Registry.mainLayer.add(group);
    Registry.shelves.push(group);
  }

  Registry.mainLayer.draw();

  Registry.AI.createAIshelve();
  createHint();
  createScore();
  createInnerMenu();
}

/**
 * [createMenu description]
 * @return {[type]} [description]
 */

function createInnerMenu() {

  var group = new Kinetic.Group({
    x: (Registry.stage.getWidth() * Registry.scale) - (300 * Registry.scale),
    y: (Registry.stage.getHeight() * Registry.scale) - (100 * Registry.scale)
  });

  var info = new Kinetic.Image({
    image: Registry.cachedImages["assets/info.png"],
    x: 0
  });

  var restart = new Kinetic.Image({
    image: Registry.cachedImages["assets/replay.png"],
    x: 100
  });

  var sound = new Kinetic.Image({
    image: Registry.cachedImages["assets/sound.png"],
    x: 200
  });

  info.on("mouseover", mouseCursor);
  info.on("mouseout", returnCursor);
  info.on("click touchstart", createInfoScreen);
  restart.on("mouseover", mouseCursor);
  restart.on("mouseout", returnCursor);
  restart.on("click touchstart", function (e) {
    totalReset();
  });

  sound.on("mouseover", mouseCursor);
  sound.on("mouseout", returnCursor);
  sound.on("click touchstart", function (e) {
    var source = $(e.targetNode.getImage()).attr("src");
    if (source === "assets/sound.png") {
      stopSound(e);
    } else {
      playSound(e);
    }

  });

  group.add(info);
  group.add(restart);
  group.add(sound);

  Registry.mainLayer.add(group);
  Registry.mainLayer.draw();

}

/**
 * [createHint description]
 * @return {[type]} [description]
 *
 * search hash: #hint
 */

function createHint() {

  var group = new Kinetic.Group({
    x: Registry.stage.getWidth() - 120,
    y: 30
  });

  var img = new Kinetic.Image({
    image: Registry.cachedImages["assets/hint.png"]
  });

  var text = new Kinetic.Text({
    text: Registry.store.getRemainingHints(),
    fontSize: 30,
    fontFamily: 'risqueregular',
    fill: '#000000',
    fontStyle: "bold",
    align: 'center',
    y: 12,
    x: 2,
    id: "hintText",
    width: 80
  });


  group.add(img);
  group.add(text);
  Registry.mainLayer.add(group);

  Registry.hints = {};
  Registry.hints = group;

  // we enable the hints if the user has remaining hints, or he can buy with credits
  Registry.hints.on("click touchstart", function () {
    if (Registry.store.hints > 0) {
      Registry.store.removeHints();
      createModal(Registry.AI.getHint(1));
      Registry.hints.find("#hintText")[0].setText(Registry.store.getRemainingHints());
      Registry.stage.draw();
    }
  });

  Registry.hints.on("mouseover", mouseCursor);
  Registry.hints.on("mouseout", returnCursor);

  Registry.mainLayer.draw();
}

/**
 * [createInfo description]
 * @return {[type]} [description]
 */

function createInfoScreen() {

  var group = new Kinetic.Group({
    width: Registry.stage.getWidth(),
    height: Registry.stage.getHeight(),
    x: 0,
    y: 0,
    id: "modal_info"
  });

  var modal = new Kinetic.Rect({
    width: Registry.stage.getWidth(),
    height: Registry.stage.getHeight(),
    x: 0,
    y: 0,
    fill: "#000000",
    opacity: 0.9
  });

  var img = new Kinetic.Image({
    image: Registry.cachedImages["assets/infoScreen.png"],
    x: ((Registry.stage.getWidth() / 2) * Registry.scale) - (217 * Registry.scale),
    y: ((Registry.stage.getHeight() / 2) * Registry.scale) - (277 * Registry.scale)
  });

  group.add(modal);
  group.add(img);
  Registry.mainLayer.add(group);

  modal.on('mousedown touchstart', function (e) {
    Registry.mainLayer.find("#modal_info")[0].destroy();
    Registry.mainLayer.draw();
  });

  Registry.mainLayer.draw();
}

/**
 * [createScore description]
 * @return {[type]} [description]
 *
 * search hash: #score, #coin
 */

function createScore() {
  var group = new Kinetic.Group({
    x: Registry.stage.getWidth() - 140,
    y: 90
  });

  var img = new Kinetic.Image({
    image: Registry.cachedImages["assets/coin2.png"],
    x: 50
  });

  var text = new Kinetic.Text({
    text: Registry.store.getCredits(),
    fontSize: 30,
    fontFamily: 'risqueregular',
    fill: '#fdd400',
    fontStyle: "bold",
    align: 'left',
    y: 12,
    x: 20,
    id: "creditsText"
  });

  group.add(img);
  group.add(text);

  Registry.coins = {};
  Registry.coins = group;

  Registry.mainLayer.add(group);
  Registry.mainLayer.draw();

}

/**
 * [updateScore description]
 * @return {[type]} [description]
 */

function updateScore() {
  var item = Registry.coins.find("#creditsText")[0].setText(Registry.store.getCredits());
  Registry.mainLayer.draw();
  Registry.stage.draw();
}

/**
 * [getChosenPotion description]
 * @param  {[type]} item [description]
 * @return {[type]}      [description]
 */

function getChosenPotion(item) {

  var currentShelf = Registry.shelves[Registry.currentPosition];
  var shelfChildren = currentShelf.getChildren();

  var result = checkPotionsOnShelf();

  if (result === false) {
    return false;
  }

  var clone = item.targetNode.clone({
    x: ((shelfChildren.length - 1) * 55) + 100,
    y: -60
  });

  clone.off('mousedown touchstart');
  currentShelf.add(clone);

  clone.on('mousedown touchstart', function (e) {
    e.cancelBubble = true;
    removeItemFromShelf(e);
  });

  Registry.mainLayer.draw();

  checkPotionsOnShelf();

}

/**
 * [removeItemFromShelf description]
 * @param  {[type]} e [description]
 * @return {[type]}   [description]
 */

function removeItemFromShelf(e) {
  e.targetNode.destroy();
  var currentShelf = Registry.shelves[Registry.currentPosition];
  var shelfChildren = currentShelf.getChildren();
  var res = Registry.mainLayer.find("#checkBtn")[0];
  if (res !== undefined) {
    res.destroy();
  }

  for (var i = 0; i < shelfChildren.length; i++) {
    if (shelfChildren[i].getName() === "itemShelf" || shelfChildren[i].getName() === "disabled") {
      continue;
    } else {
      shelfChildren[i].setX(((i - 1) * 55) + 100);
    }
  }


  Registry.mainLayer.draw();
}

/**
 * [checkPotionsOnShelf description]
 * @return {[type]} [description]
 */

function checkPotionsOnShelf() {
  var currentShelf = Registry.shelves[Registry.currentPosition];
  var shelfChildren = currentShelf.getChildren();

  if (shelfChildren.length === 7) {

    var test = new Kinetic.Image({
      image: Registry.cachedImages["assets/test.png"],
      x: (Registry.stage.getWidth() * 0.7) - (160 * 0.7),
      y: -60,
      id: "checkBtn"
    });

    test.on("mousedown touchstart", testCombination);
    test.on("mouseover", mouseCursor);
    test.on("mouseout", returnCursor);
    currentShelf.add(test);
    Registry.mainLayer.draw();

    return false;
  } else if (shelfChildren.length > 7) {
    return false;
  } else {
    return true;
  }
}

/**
 * [testCombination description]
 * @return {[type]} [description]
 */

function testCombination(e) {

  var currentShelf = Registry.shelves[Registry.currentPosition];
  var shelfChildren = currentShelf.getChildren();
  var potions = [];
  for (var i = 0; i < shelfChildren.length; i++) {
    var item = shelfChildren[i];
    if (item.getName() === "potion") {
      potions.push({
        "item": item,
        "type": item.getId()
      });
    }
  }

  var tween = new Kinetic.Tween({
    node: e.targetNode,
    duration: 0.6,
    opacity: 0,
    scale: 0.1,
    onFinish: function () {
      checkValidCombination(potions);
      for (var i = 0; i < shelfChildren.length; i++) {
        //window.console.log(shelfChildren[i]);
        if (shelfChildren[i].getType() !== "Group") {
          shelfChildren[i].setName("disabled");
          shelfChildren[i].off('mousedown touchstart');
        }
      }
    }
  });

  tween.play();
}

function checkValidCombination(potions) {
  var combo = Registry.AI.getCombo();
  var results = [];
  var innerIndex = 0;
  var tempResults = [];
  var burnedIndexes = [];
  var result = null;

  for (var i = 0; i < potions.length; i++) {
    result = null;
    //window.console.log("===================");
    for (var k = innerIndex; k < combo.length; k++) {
      var selectedItem = potions[i];
      var aiItem = combo[k];

      // check color
      //window.console.log(String(aiItem.type).toLowerCase());
      if (String(selectedItem.type).toLowerCase() === String(aiItem.type).toLowerCase()) {
        if (k === i) {
          result = "TT";
          combo[k].type = "burned";
          burnedIndexes.push(i);
          break;
        }

      }
    }

    // pushing result and if it is TT, we remove the entry
    if (result !== null) {
      results.push(result);
    }
  }

  ////// RE-CHECKING THE REST ////////
  for (var j = 0; j < potions.length; j++) {
    result = null;
    // if it finds the index in there
    if (_.indexOf(burnedIndexes, j) !== -1) {
      continue;
    }
    for (var m = innerIndex; m < combo.length; m++) {
      var selectedItem = potions[j];
      var aiItem = combo[m];

      if (String(selectedItem.type).toLowerCase() === String(aiItem.type).toLowerCase()) {
        result = "TF";
        combo[m].type = "burned";
        break;
      } else {
        result = "FF";
      }

    }

    if (result !== null) {
      window.console.log(result);
      results.push(result);
    }
  }

  var result = createPins(results);
  if (result === undefined || result === false) {
    endRound(results);
  }
}

/**
 * [createPins description]
 * @param  {[type]} results [description]
 * @return {[type]}         [description]
 */

function createPins(results) {
  var group = new Kinetic.Group({
    x: (Registry.stage.getWidth() * 0.7) - (170 * 0.7),
    y: -60
  });

  var res = _.groupBy(results);
  results = groupByType(res);
  results = results.sort();
  results.reverse();

  var currentShelf = Registry.shelves[Registry.currentPosition];
  var scale = Registry.scale;
  for (var i = 0; i < results.length; i++) {

    var type;
    if (results[i] === "TT") {
      type = "assets/colorAndPosition.png";
    } else if (results[i] === "TF") {
      type = "assets/noPosition.png";
    } else {
      type = "assets/nothing.png";
    }

    if (Registry.scale > 0.7) {
      scale = 0.7;
    }

    //calculations//
    var _x = (i * 50 * scale) + 10;
    if (i >= 3) {
      _x = ((i - 3) * 50 * scale) + 10;
    }
    var _y = i >= 3 ? (50 * scale) : 0;

    var pin = new Kinetic.Image({
      image: Registry.cachedImages[type],
      x: _x,
      y: _y,
      scale: 0,
      opacity: 0
    });

    group.add(pin);

  }

  currentShelf.add(group);
  Registry.mainLayer.draw();

  for (var k = 0; k < group.getChildren().length; k++) {
    var item = group.getChildren()[k];
    var tween = new Kinetic.Tween({
      node: item,
      duration: (0.3 * k),
      opacity: 1,
      scaleX: scale,
      scaleY: scale,
      easing: Kinetic.Easings.BackEaseOut
    });

    tween.play();

  }

  return checkForVictory(res);
}

/**
 * [checkForVictory description]
 * @param  {[type]} results [description]
 * @return {[type]}         [description]
 */

function checkForVictory(results) {
  if (results.TT !== undefined) {
    if (results.TT.length === 6) {
      createModal("Victory!", "New Game?");
      //increaseScore();
      Registry.store.addCredits();
      Registry.store.saveStoreInfo();
      updateScore();
      return true;
    } else {
      return false;
    }
  } else {
    return false;
  }
}

/**
 * [endRound description]
 * @return {[type]} [description]
 */

function endRound() {
  Registry.currentPosition += 1;
  if (Registry.currentPosition === 5) {
    Registry.store.addHints();
    createModal("You have an additional hint!");
    Registry.hints.find("#hintText")[0].setText(Registry.store.getRemainingHints());
    Registry.stage.draw();
  }

  if (Registry.currentPosition >= 6) {
    window.console.log("GAME OVER!");
    createModal("Game Over", "New Game?");
    Registry.AI.revealCombination();
  }
}


/**
 * [TotalReset description]
 */

function totalReset() {

  //Registry.store = new store();
  Registry.store.resetHints();

  removeAI();
  var layerChildren = Registry.mainLayer.getChildren();
  window.console.log(layerChildren.length, layerChildren);
  var toBeRemoved = Registry.mainLayer.find(".shelfGroup");
  toBeRemoved.each(function (shape) {
    shape.destroyChildren();
    shape.destroy();
  });



  Registry.shelves = [];
  Registry.mainLayer.draw();
  window.console.log(layerChildren.length);

  //Registry.stage.draw();
  Registry.currentPosition = 0;

  createBigShelves();
  updateScore();

  var modal = Registry.mainLayer.find("#modal")[0];
  if (modal !== undefined) {
    modal.destroy();
  }

  Registry.stage.draw();
}

/**
 * [removeAI description]
 * @return {[type]} [description]
 */

function removeAI() {
  Registry.AIGroup.destroyChildren();
  Registry.AIGroup.destroy();
  Registry.mainLayer.draw();
}


///////////////////////////////////////////////////////////////////

/**
 * [createModal description]
 * @return {[type]} [description]
 *
 * search hash: #modal
 */

function createModal(message, message2) {

  var group = new Kinetic.Group({
    width: Registry.stage.getWidth(),
    height: Registry.stage.getHeight(),
    x: 0,
    y: 0,
    id: "modal"
  });

  var modal = new Kinetic.Rect({
    width: Registry.stage.getWidth(),
    height: Registry.stage.getHeight(),
    x: 0,
    y: 0,
    fill: "#000000",
    opacity: 0.7
  });

  var text = new Kinetic.Text({
    x: (((Registry.stage.getWidth())) / 2) - (458 / 2) + 70,
    y: ((Registry.stage.getHeight()) / 2),
    text: message,
    fontSize: 55,
    fontFamily: 'risqueregular',
    fill: '#000000',
    width: 360,
    align: 'center'
  });

  text.setY(text.getY() - (text.getHeight() / 2) - 10);

  ////////////
  if (message2 !== undefined) {
    text.setY(text.getY() - (text.getHeight() / 2) - 30);

    var text2 = new Kinetic.Text({
      x: (((Registry.stage.getWidth())) / 2) - (458 / 2) + 70,
      y: ((Registry.stage.getHeight()) / 2) + 30,
      text: message2,
      fontSize: 55,
      fontFamily: 'risqueregular',
      fill: '#a6ce3a',
      width: 360,
      align: 'center'
    });

    text2.on("mouseover", mouseCursor);
    text2.on("mouseout", returnCursor);
  }

  var parchment = new Kinetic.Image({
    image: Registry.cachedImages["assets/modal.png"],
    width: 458,
    height: 309,
    x: (((Registry.stage.getWidth() + 60)) / 2) - (458 / 2),
    y: (Registry.stage.getHeight()) / 2 - (309 / 2)
  });

  group.add(modal);
  group.add(parchment);
  group.add(text);
  if (message2 !== undefined) {
    group.add(text2);
    text2.on("mousedown touchstart", function () {
      totalReset();
    });
  } else {
    modal.on('mousedown touchstart', function (e) {
      Registry.mainLayer.find("#modal")[0].destroy();
      Registry.mainLayer.draw();
    });
  }
  Registry.mainLayer.add(group);
  Registry.mainLayer.draw();

}

/**
 * [createLoader description]
 * @param  {[type]} num [description]
 * @return {[type]}     [description]
 */

function createLoader(num) {

  Registry.totalLoadedImages = num;
  var loaderLayer = new Kinetic.Layer();
  var group = new Kinetic.Group({
    width: Registry.stage.getWidth() * Registry.scale,
    height: Registry.stage.getHeight() * Registry.scale,
    x: 0,
    y: 0,
    id: "modal"
  });

  var innerGroup = new Kinetic.Group({
    width: 458 * Registry.scale,
    height: 309 * Registry.scale,
    x: ((((Registry.stage.getWidth() * Registry.scale) + 60)) / 2) - ((458 * Registry.scale) / 2),
    y: ((Registry.stage.getHeight() * Registry.scale)) / 2 - (309 / 2)
  });

  var modal = new Kinetic.Rect({
    width: Registry.stage.getWidth() * Registry.scale,
    height: Registry.stage.getHeight() * Registry.scale,
    x: 0,
    y: 0,
    fill: "#000000",
    opacity: 0.7
  });

  var text = new Kinetic.Text({
    x: (458 * Registry.scale) / 2,
    y: (309 * Registry.scale) / 2,
    text: "LOADING ASSETS...",
    fontSize: 55 * (Registry.scale - 0.2),
    fontFamily: 'risqueregular',
    fill: '#000000',
    width: 360,
    align: 'center'
  });

  text.setY(text.getY() - (text.getHeight() / 2) - (55 * (Registry.scale - 0.2)));
  text.setX(text.getX() - (text.getWidth() / 2));

  var parchment = new Kinetic.Rect({
    width: 458 * Registry.scale,
    height: 309 * Registry.scale,
    x: 0,
    y: 0,
    fill: "#ffcc00",
    fillLinearGradientStartPoint: {
      x: -(458 / 2),
      y: 0
    },
    fillLinearGradientEndPoint: {
      x: 50,
      y: 50
    },
    fillLinearGradientColorStops: ['#fec72c', '#ffcc00'],
    shadowColor: 'black',
    shadowBlur: 10,
    shadowOffset: {
      x: 0,
      y: 0
    },
    shadowOpacity: 0.3
  });

  var bar = new Kinetic.Rect({
    x: (458 * Registry.scale) / 2 - (400 * Registry.scale) / 2,
    y: (309 * Registry.scale) - ((50 * Registry.scale) + 20),
    width: 400 * Registry.scale,
    height: 50 * Registry.scale,
    strokeWidth: 2,
    stroke: "#000000"
  });

  var perc = new Kinetic.Rect({
    x: (458 * Registry.scale) / 2 - (400 * Registry.scale) / 2 + 1,
    y: (309 * Registry.scale) - ((46 * Registry.scale) + 22),
    width: 0,
    height: 46 * Registry.scale,
    id: "loader",
    fill: "#ff00d0"
  });

  group.add(modal);
  innerGroup.add(parchment);
  innerGroup.add(text);
  innerGroup.add(bar);
  innerGroup.add(perc);

  group.add(innerGroup);
  loaderLayer.add(group);
  Registry.loader = loaderLayer;

  Registry.stage.add(loaderLayer);
  Registry.stage.draw();

}

/**
 * [updateLoader description]
 * @return {[type]} [description]
 */

function updateLoader(kill) {

  //&& Registry.musicLoaded === true
  var tween;
  if (kill === "kill" && Registry.musicLoaded === true) {
    tween = new Kinetic.Tween({
      node: Registry.loader,
      duration: 1,
      opacity: 0,
      onFinish: function () {
        Registry.loader.destroy();
      }
    });

    tween.play();
  } else if (Registry.assetsLoaded === true && Registry.musicLoaded === true) {
    tween = new Kinetic.Tween({
      node: Registry.loader,
      duration: 1,
      opacity: 0,
      onFinish: function () {
        Registry.loader.destroy();
      }
    });

    tween.play();
  }

  var wPerImage = Math.ceil((400 * Registry.scale) / Registry.totalLoadedImages - 1);
  var item = Registry.loader.find("#loader")[0];
  if (item !== undefined) {
    var currentWidth = item.getWidth();
    item.setWidth(currentWidth + wPerImage);
    Registry.stage.draw();

    if (currentWidth >= 380) {
      window.console.log("ALL LOADED!");
      var tween = new Kinetic.Tween({
        node: Registry.loader,
        duration: 1,
        opacity: 0,
        onFinish: function () {
          Registry.loader.destroy();
        }
      });

      tween.play();
    }
  }
}

/**
 * [stopSound description]
 * @param  {[type]} e [description]
 * @return {[type]}   [description]
 */

function stopSound(e) {
  window.console.log("stoping sound: ", e);
  audio.stop();
  e.targetNode.setImage(Registry.cachedImages["assets/nosound.png"]);
  Registry.stage.draw();
}

/**
 * [playSound description]
 * @param  {[type]} e [description]
 * @return {[type]}   [description]
 */

function playSound(e) {
  window.console.log("playing sound: ", e);
  audio.play();
  e.targetNode.setImage(Registry.cachedImages["assets/sound.png"]);
  Registry.stage.draw();
}

/**
 * [checkSize description]
 * @return {[type]} [description]
 */

function checkSize(noStage) {

  var w = $(window).width();
  var h = $(window).height();

  var hPerc = (h - 20) / 1024;
  var wPerc = 810 / w;

  if (noStage === true) {
    if (h < 1024) {
      Registry.scale = Math.round(hPerc);
    } else {
      Registry.scale = 1;
    }

    return true;
  }
  var finalW = Math.round(810 * hPerc);
  window.console.log(wPerc, finalW);

  if (h < 1024) {
    Registry.stage.setScale(hPerc);
    $("#board").height(h - 20);
    $("#board").width(finalW);
    $("#board").css('margin-left', (finalW / 2) * -1);
    Registry.scale = Math.round(hPerc);
  } else {
    Registry.scale = 1;
  }
}

/**
 * [groupByType description]
 * @return {[type]} [description]
 */

function groupByType(res) {
  var results = [];
  $.each(res, function (key, value) {
    for (var i = 0; i < value.length; i++) {
      results.push(value[i]);
    }
  });

  return results;
}



/**
 * [initBackground description]
 * @return {[type]} [description]
 */

function initBackground() {
  /* color transitions */
  var colors = new Array(
  [62, 35, 255], [60, 255, 60], [255, 35, 98], [45, 175, 230], [255, 0, 255], [255, 128, 0]);

  var step = 0;
  //color table indices for:
  // current color left
  // next color left
  // current color right
  // next color right
  var colorIndices = [0, 1, 2, 3];

  //transition speed
  var gradientSpeed = 0.002;

  function updateGradient() {
    var c0_0 = colors[colorIndices[0]];
    var c0_1 = colors[colorIndices[1]];
    var c1_0 = colors[colorIndices[2]];
    var c1_1 = colors[colorIndices[3]];

    var istep = 1 - step;
    var r1 = Math.round(istep * c0_0[0] + step * c0_1[0]);
    var g1 = Math.round(istep * c0_0[1] + step * c0_1[1]);
    var b1 = Math.round(istep * c0_0[2] + step * c0_1[2]);
    var color1 = "#" + ((r1 << 16) | (g1 << 8) | b1).toString(16);

    var r2 = Math.round(istep * c1_0[0] + step * c1_1[0]);
    var g2 = Math.round(istep * c1_0[1] + step * c1_1[1]);
    var b2 = Math.round(istep * c1_0[2] + step * c1_1[2]);
    var color2 = "#" + ((r2 << 16) | (g2 << 8) | b2).toString(16);

    $('#gradient').css({
      background: "-webkit-gradient(linear, left top, right top, from(" + color1 + "), to(" + color2 + "))"
    }).css({
      background: "-moz-linear-gradient(left, " + color1 + " 0%, " + color2 + " 100%)"
    });

    step += gradientSpeed;
    if (step >= 1) {
      step %= 1;
      colorIndices[0] = colorIndices[1];
      colorIndices[2] = colorIndices[3];

      //pick two new target color indices
      //do not pick the same as the current one
      colorIndices[1] = (colorIndices[1] + Math.floor(1 + Math.random() * (colors.length - 1))) % colors.length;
      colorIndices[3] = (colorIndices[3] + Math.floor(1 + Math.random() * (colors.length - 1))) % colors.length;

    }
  }

  setInterval(updateGradient, 10);
}